function StateManager(synchronizations)
{
    this.synchronizations = synchronizations;
    this.deletePath=deletePath;
    this.getPaths=getPaths;

    this.selection = new Selection();
    this.getSelection = getSelection;
    this.getSelectedNodeKey = getSelectedNodeKey;
    this.override = override;
    this.save = save;
}

function deletePath(name){

    var syncId = this.selection.getSyncId();
    var indexToDelete = null;

    $.each(this.synchronizations[syncId].paths, function(index, value) {
        if (value.path == name){
              indexToDelete = index;
        }
    });

    if (indexToDelete != null)
        this.synchronizations[syncId].paths.splice(indexToDelete, 1);

}

function getPaths() {
    return this.synchronizations[this.selection.getSyncId()].paths;
}

function getSelection(){
    return this.selection;
}

function getSelectedNodeKey() {

    var syncId = this.selection.getSyncId();
    var pathId = this.selection.getPathId();

    var storageId = null;
    var login = null;
    var folder = null;

    if (pathId != null){
        var path = this.synchronizations[syncId].paths[pathId];
        storageId = path.storageId;
        login = path.login;
        folder = path.path;
    }

    var nodeKey = new NodeKey(storageId, login, folder);

    return this.override(nodeKey);
}

function override(nodeKey) {

    var storageId = this.selection.getStorageId();
    if ( storageId != null)
        nodeKey.storageId = storageId;

    var login = this.selection.getLogin();
    if ( login != null)
        nodeKey.login = login;

    var path = this.selection.getPath();
    if ( path != null)
        nodeKey.path = path;

    return nodeKey;

}

function save() {

    var syncId = this.selection.getSyncId();
    var pathId = this.selection.getPathId()
    var nodeKey = this.getSelectedNodeKey();

    if (pathId != null){
        this.synchronizations[syncId].paths[pathId] = nodeKey;
    } else {
        this.synchronizations[syncId].paths.push(nodeKey);
    }
}